#!/usr/bin/perl
package GOBLIN;
our $VERSION = '0.10';
;########################################################################
;### goblin.pl - Merge the blacklists between the sites
;### 		Programmed by Piroli YUKARINOMIYA (Open MagicVox)
;### 		@see http://www.magicvox.net/archive/2005/10192350.php

use strict;
use CGI::Carp qw(fatalsToBrowser);
use LWP::UserAgent;

;### TCg̃ubNXgւ̃pX
our $BListPath = '/home/your/path/blist.txt';

;### TCgQƂ鑼TCǧJubNXg URL 
our @BListList = (
	'http://www.example.com/~hoge/blist.txt',
	'http://foo.example.com/~hage/any/path/blist.txt',
);

;### LPOP@(0 ɂƊOQƂȂ̂ 1 ȏݒ)
our $POPCount = 2;



print "Content-type: text/plain\n\n";# exec as CGI

;########################################################################
;### TCg̃Xgǂݍ
print "Processing: $BListPath\n";
if (! open (BLACKLIST, "<$BListPath")) {
	print "\tProgram abort - Can't open the file\n";
	exit;
}
my $buf;
$buf .= $_ while (<BLACKLIST>);
close (BLACKLIST);
my $mylist = LimitPOP (ParseList ($buf), $POPCount);
print "\n";

;### TCg̃Xgƃ}[W
foreach my $url (@BListList) {
	;# url 擾
	print "Processing: $url\n";
	my $ua = LWP::UserAgent->new;
	$ua->agent (__PACKAGE__. "/$VERSION");
	$ua->timeout (30);
	my $res = $ua->request (HTTP::Request->new (GET => $url));
	if (! $res->is_success) {
		;# G[
		print "\tSkipped - The server returned '". $res->status_line. "'\n";
		next;
	}
	my $yourlist = LimitPOP (ParseList ($res->content), $POPCount - 1);
	my $items_update = 0;
	my $items_add = 0;
	foreach my $ip (keys %{$yourlist}) {
		if ($$mylist{$ip}) {
			;# ߂TCg̃ACeōXV
			if (scalar (@{$$yourlist{$ip}}) + 1 < scalar (@{$$mylist{$ip}})) {
				my @pops = ($url, @{$$yourlist{$ip}});
				$$mylist{$ip} = \@pops;
				$items_update++;
			}
		} else {
			;# ̃Xgɖꍇ͖Œǉ
			my @pops = ($url, @{$$yourlist{$ip}});
			$$mylist{$ip} = \@pops;
			$items_add++;
		}
	}
	print "\tAdded $items_add items, and $items_update items were updated.\n\n";
}

;### ߂
print "Updating: $BListPath\n";
if (! open (BLACKLIST, ">$BListPath")) {
	print "\tProgram abort - Can't create the file\n";
	exit;
}
foreach my $ip (keys %{$mylist}) {
	print BLACKLIST join ("\t", ($ip, @{$$mylist{$ip}})). "\n";
}
close (BLACKLIST);
print "\tDone\n";
exit;



;########################################################################
;### Xgp[X
sub ParseList {
	my $buf = shift;
	my %ret;
	my @lines = split (/[\r\n]/, $buf);
	my $items = 0;
	foreach my $line (@lines) {
		my @column = split (/[\t]/, $line);
		next if ($#column < 0);
		my ($ip) = $column[0] =~ /^([\d\.]+)/;
		next if (! $ip);
		my @pops;
		for my $i (1..$#column) { push @pops, $column[$i]; }
		$ret{$ip} = \@pops;
		$items++;
	}
	print "\thas $items items (". length($buf). " bytes)\n";
	\%ret;
}

;### w肳ꂽPOPŃJbg
sub LimitPOP {
	my ($blist, $pops) = @_;
	my %ret;
	my $items = 0;
	foreach my $k (keys %{$blist}) {
		next if ($pops < scalar (@{$$blist{$k}}));
		$ret{$k} = $$blist{$k};
		$items++;
	}
	print "\t$items items are available within the pop count.\n";
	\%ret;
}
__END__
